
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/time.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <signal.h>

#include <iostream>

using namespace std;

#define TIMESTAMP(s); {\
	timeval tv;\
	char time_str[100];\
	gettimeofday(&tv,NULL);\
	strftime(time_str, 100, "%F %H:%M:%S", localtime(&tv.tv_sec));\
	cout << time_str << ":" << tv.tv_usec << "  Parent Process: " << s << endl;\
	}


void catch_child(int sig_num)
{
	int child_status;

	wait(&child_status);
	cout << "child exited!" << endl;
}

int main(void)
{
	pid_t pid;
	int child_status;

	signal(SIGCHLD, catch_child);

	TIMESTAMP("Start!");
	if ((pid = fork()) < 0) {
		perror("fork");
		exit(1);
	} else if (pid == 0){					// child-1
		TIMESTAMP("Child process-1 fork!");
		char* argv[] = {(char *)"process1", (char *)"10", NULL};
		char* envp[] = {(char *)"LD_LIBRARY_PATH=/usr/local/cuda/lib", NULL};
		int rt = execve("./process1", argv, envp);
		if (rt == -1)
			cout << "!!ERROR!!" << endl;
		cout << "child go there after execve." << endl;
		exit(0);
	}

	/*parent*/
	for(int i = 0; i<10; i++){
		TIMESTAMP("count..");
		sleep(1);
	}
	TIMESTAMP("End!");
}
